<?
//    -------------------------------------------------------------------------------
//    $Id: Site.php,v 1.5 2002/12/23 11:33:58 jonen Exp $
//    -------------------------------------------------------------------------------
//    $Log: Site.php,v $
//    Revision 1.5  2002/12/23 11:33:58  jonen
//    + minor changes
//
//    Revision 1.4  2002/12/19 16:25:29  joko
//    + function loadCmsPage($template, $data_merge = array())
//
//    Revision 1.3  2002/12/19 06:17:32  joko
//    + database, smarty, and langtext (lt) now gets initialized here (on Site startup)
//
//    Revision 1.2  2002/12/13 09:17:41  joko
//    + function getLastRequest
//    + function cacheRequest
//
//    Revision 1.1  2002/11/12 05:42:30  joko
//    + initial checkin
//
//    Revision 1.3  2002/10/25 15:14:50  cvsjoko
//    + generic logging mechanism via PEAR::Log
//
//    Revision 1.2  2002/10/20 21:52:00  cvsmax
//    + add new
//      + function cacheThisRequest($request)  # save current request in session
//      + function getCachedRequest()		 # get cached request from session
//
//    Revision 1.1  2002/10/09 00:42:50  cvsjoko
//    + much code from "lib/menu/libnav.php.inc"
//    -------------------------------------------------------------------------------


require_once 'Site/Boot.php';

class Site extends Site_Boot {
//class Site extends PEAR_Autoloader {

  // this collects all/some stuff (object variables and methods) 
  // from other (helper)-objects and acts as a dispatcher to them...
  // ...is this a bridge then?
  
  // TODO:
  // - "Request" depends on "Handler" for now ;(
  // - application should croak if preboot doesn't exist inside config
  // - implement autoloading mechanism via php's overload

  // essentials (more or less)
  var $config;      // config  ...is very essential (especially preboot stuff)
  var $logger;     // logging? yea
  var $db;          // the database handle (actually a PEAR::DB)
  var $smarty;   // a reference to a new smarty object, do templating stuff with that
  
  // some helper objects
  var $handler;     // keeps track of handlers and identifiers
  var $request;    // takes care about the requests
  var $loader;     // loads various components (lib, page, file, etc.)
  var $misc;       // not needed yet, just wastes space
  
  // some application objects
  var $session;
  var $user;

  function Site(&$config) {
    // this will not work, logger is initialized two lines below
    $this->log( get_class($this) . "->Site( config $config )", LOG_DEBUG );
    $this->config = $config;
    $this->_init_logger();
    $this->_init_helpers();
    $this->_init_application();
    $this->_init_database();
    $this->_init_smarty();
    $this->_init_lt();
  }

  // Dispatchers for all subobjects
    // TODO:
    //    - make this much more generic
    //    - maybe use "aggregate" if it becomes available
    //    - there is some function to get given args to a function from inside it, use this perhaps
    //    - patch php to support multiple inheritance   ;)

  // dispatchers for Handler
  function &encodeIdentifier($a) {
    return $this->handler->encodeIdentifier($a);
  }
  function &decodeIdentifier($a) {
    return $this->handler->decodeIdentifier($a);
  }
  function &getPageIdentifier() {
    return $this->handler->getPageIdentifier();
  }
  function &setHandler($a, $b) {
    return $this->handler->setHandler($a, $b);
  }
  function getHandler($a) {
    return $this->handler->getHandler($a);
  }

  // dispatchers for Request
  function getRequest() {
    return $this->request->getRequest();
  }

  function getLastRequest() {
    return $this->request->getCached();
  }

  function cacheRequest($request = array()) {
    return $this->request->cacheRequest($request);
  }

  // dispatchers for Loader
  function &loadHandler($a) {
    return $this->loader->loadHandler($a);
  }
  function &loadPage($a, $b = array()) {
    return $this->loader->loadPage($a, $b);
  }
  function &loadTemplate($a, $b = array(), $c = "") {
    return $this->loader->loadTemplate($a, $b, $c);
  }

  // dispatchers for Http
  function &redirect($a) {
    return $this->http->redirect($a);
  }
  


  // TODO: throw these out!

  function getLink($key, $attribs = array()) {
    //dprint("getlink: " . dumpvar($attribs));
    $ident = $this->encodeIdentifier($key);
    // base url with ident
    $url = $_SERVER[PHP_SELF] . '?' . 'x=' . $ident;
    // additional arguments?
    foreach ($attribs as $key => $value) {
      $url .= '&' . $key . '=' . $value;
    }
    return $url;
  }
  
  function isAuthenticated() {
    //global $uservars_db;
    //return isset($uservars_db[status]);
    global $site;
    return $site->user->isLoggedOn();
  }
  
  function log($msg, $level) {
    if ($this->logger) {
      $this->logger->log($msg, $level);
    } else {
      // TODO: how are these type of errors handled?
      //print "error-message: $msg<br>";
    }
  }
  
  function loadCmsPage($template, $data_merge = array()) {
    
//print Dumper($this->getRequest());
    
    // default data to provide to scope of cms
    // TODO/REVIEW: should we be more strict here?
    // e.g. just pass in '$site->config->url' or s.th.l.th.
    $data = array(
      'config' => $this->config,
      'request' => $this->getRequest(),
    );
    
    // merge in additional data
    foreach ($data_merge as $key => $val) {
      $data[$key] = $val;
    }
    
    // load template
    $this->loadTemplate($template, $data);
    
  }
  
}

?>