<?
//    -------------------------------------------------------------------------
//    $Id: Template.php,v 1.2 2002/12/19 10:33:49 joko Exp $
//    -------------------------------------------------------------------------
//    $Log: Template.php,v $
//    Revision 1.2  2002/12/19 10:33:49  joko
//    + debugging and bugfixing
//
//    Revision 1.1  2002/12/19 06:20:39  joko
//    + initial check-in
//
//    -------------------------------------------------------------------------

class Site_Template {
  
  var $meta;
  
  function start() {
//print "START<br>";
  }

  function _register_langtext_safe() {
    if (!$this->meta[registered][lt]) {
      $this->meta[registered][lt] = 1;
      $this->_register_langtext();
    }
  }

  function _register_langtext() {
//print "REGISTER<br>";
    // register 'lt' (LangText) template provider
    $this->site->smarty->register_resource(
      "lt", 
      array(
        "db_get_template",
        "db_get_timestamp"
      )
    );
/*
      array(
        "db_get_template",
        "db_get_timestamp",
        "db_get_secure",
        "db_get_trusted"
      )
*/
  }

  function display($identifier, $options) {
//print "DISPLAY<br>";
    $this->_build($identifier, $options);
  }

  function get($identifier, $interpolate = array()) {
//print "GET<br>";
    // TODO: review... what about the cache-key here? use volatile by default or not?
    // for now: per default to be _very_ safe....    ;)
    $options = array(
      'interpolate' => $interpolate,
      'return' => 1,
      'cache_key' => 'volatile'
    );
//      'cache_key' => 'volatile'
    return $this->_build($identifier, $options);
  }

  function _build($identifier, $options) {

//print "BUILD identifier $identifier<br>";
//print "options:<br>" . Dumper($options) . "<br>";

    $this->_register_langtext_safe();

        // TODO: just do '$this->site->smarty->assign($arguments[vars]);' ???
        /*
        foreach ($arguments[vars] as $name => $value) {
          $this->site->smarty->assign($name, $value);
        }
        */
        
        // template variable interpolation
        if ($options['interpolate']) {
          $this->site->smarty->assign($options['interpolate']);
        }
        
//print "cached: " . $this->site->smarty->is_cached($identifier) . "<br>";
        
        // TODO: refactor this!
        // $smarty_method = 'fetch|display'
        // $cache_key???
        if ($options['return']) {

//print "RETURN<br>";

          // return template
          // use of cache-key per template
          if ($cache_key = $options['cache_key']) {
//print "1: $cache_key<br>";
            if ($cache_key == 'volatile') {
              //$this->site->smarty->clear_cache($identifier, $cache_key);
              //$this->site->smarty->clear_cache('referer.php');
            }
            $result = $this->site->smarty->fetch($identifier, $cache_key);
          } else {
//print "2<br>";
            $result = $this->site->smarty->fetch($identifier);
          }
//print "result: $result<br>";

        } else {
        
          // display template
          // use of cache-key per template
          if ($cache_key = $options['cache_key']) {
            $result = $this->site->smarty->display($identifier, $cache_key);
          } else {
            $result = $this->site->smarty->display($identifier);
          }

        }
              
        return $result;

  }

}


function db_get_template($tpl_name, &$tpl_source, &$smarty_obj)
{
  //print "db_get_template: '$tpl_name', '$tpl_source', '$smarty_obj'<br>";
  //return $this->site->lt->getlt($tpl_name);
  global $site;
  if ($template = $site->lt->getlt($tpl_name, array(), 1)) {
//print "template: '$template'<br>";
    $tpl_source = $template;
    return true;
  }
}

function db_get_timestamp($tpl_name, &$tpl_timestamp, &$smarty_obj)
{
  $tpl_timestamp = time();
  return true;
}


/*

// ----------------------------------------------------------------------------------
// from: http://smarty.php.net/manual/en/templates.from.elsewhere.html
// ----------------------------------------------------------------------------------


// from PHP script

// put these function somewhere in your application
function db_get_template ($tpl_name, &tpl_source, &$smarty_obj)
{
    // do database call here to fetch your template,
    // populating $tpl_source
    $sql = new SQL;
    $sql->query("select tpl_source
                   from my_table
                  where tpl_name='$tpl_name'");
    if ($sql->num_rows) {
        $tpl_source = $sql->record['tpl_source'];
        return true;
    } else {
        return false;
    }
}

function db_get_timestamp($tpl_name, &$tpl_timestamp, &$smarty_obj)
{
    // do database call here to populate $tpl_timestamp.
    $sql = new SQL;
    $sql->query("select tpl_timestamp
                   from my_table
                  where tpl_name='$tpl_name'");
    if ($sql->num_rows) {
        $tpl_timestamp = $sql->record['tpl_timestamp'];
        return true;
    } else {
        return false;
    }
}

function db_get_secure($tpl_name, &$smarty_obj)
{
    // assume all templates are secure
    return true;
}

function db_get_trusted($tpl_name, &$smarty_obj)
{
    // not used for templates
}

// register the resource name "db"
$smarty->register_resource("db", array("db_get_template",
                                       "db_get_timestamp",
                                       "db_get_secure",
                                       "db_get_trusted"));

// using resource from php script
$smarty->display("db:index.tpl");

{* using resource from within Smarty template *}
{include file="db:/extras/navigation.tpl"}

// ----------------------------------------------------------------------------------

*/


?>